\RequirePackage{fix-cm}
%
%\documentclass{svjour3}                     % onecolumn (standard format)
%\documentclass[smallcondensed]{svjour3}     % onecolumn (ditto)
%\documentclass[smallextended]{svjour3}       % onecolumn (second format)
\documentclass[twocolumn]{svjour3}          % twocolumn
%
\smartqed  % flush right qed marks, e.g. at end of proof
%
\usepackage{graphicx}
\usepackage{mathptmx}
%
% insert here the call for the packages your document requires
\usepackage{amsmath, amsfonts}
%
% please place your own definitions here and don't use \def but \newcommand{}{}
\newcommand{\bR}{\mathbb{R}}
\newcommand{\bN}{\mathbb{N}}
\newcommand{\bC}{\mathbb{C}}
\newcommand{\bZ}{\mathbb{Z}}
\newcommand{\cA}{\mathcal{A}}
\newcommand{\cB}{\mathcal{B}}
\newcommand{\cN}{\mathcal{N}}
\newcommand{\cH}{\mathcal{H}}
\newcommand{\cBo}{\partial \mathcal{B}}
\newcommand{\cF}{\mathcal{F}}
\newcommand{\Arg}{\operatorname{Arg}}
\newcommand{\rank}{\operatorname{rank}}
\newcommand{\Dez}{\Delta z}
\newcommand{\ival}[2]{\overline{#1, \ldots , #2}}
%
% Insert the name of "your journal" with
\journalname{Nonlinear dynamics}

\begin{document}

\title{Relation between fractal dimension and Wada measure in Newton's discrete dynamical system}
\titlerunning{Fractal dimension and Wada measure}

\author{Pranas Ziaukas \and Minvydas Ragulskis}
%\authorrunning{Short form of author list} % if too long for running head

\institute{M.~Ragulskis \at
           Department of Mathematical Modeling, Kaunas University of Technology, Kaunas, Lithuania \\
           Tel.: +370 698 22456 \\
           \email{minvydas.ragulskis@ktu.lt}
           \and
           P.~Ziaukas \at
           Department of Mathematical Modeling, Kaunas University of Technology, Kaunas, Lithuania \\
           Tel.: +370 629 57744 \\
           \email{prazia@ktu.lt}
}

\date{Received: date / Accepted: date}
% The correct dates will be entered by the editor

\maketitle



\begin{abstract}
Chaotic processes are analyzed in this thesis using multiple techniques.
A relaxed Newton's discrete dynamical system with a complex control parameter is chosen and simulated numerically.
Different set-ups of attracting basins are obtained along with their boundaries.
The fractal dimensions of basin boundaries are measured using the box counting algorithm.
The Wada qualities of basins are evaluated using a novel proposed algorithm.
Both characteristics are compared in a two-dimensional parameter plane, non-trivial relations between them are emphasized.
Examples of a complex transient behavior under certain conditions are provided.
Finally, advantages and disadvantages of a proposed Wada characteristic are discussed, and recommendations are made regarding further research.
\keywords{Dynamical systems \and Chaos \and Attractors \and Fractal dimension \and Wada property}
% \PACS{PACS code1 \and PACS code2 \and more}
% \subclass{MSC code1 \and MSC code2 \and more}
\end{abstract}



\section{Introduction}
\paragraph{Newton's discrete dynamical system}
NDDS can be used to analyze dynamical systems of varying degree of difficulty. 
In~\cite{Holt1984} Newton's method is considered as an iterative scheme to compute the complicated basins of attraction for some discrete dynamical systems.
The chaotic number of iterations needed by Newton’s method to converge to its attractors is discussed in~ \cite{Susanto2009}.
A general behavior of Newton's method for cubic polynomials is investigated in~\cite{Walsh1995}, including the emergence of period-three orbits.

The emergence of fractals in NDDS is well-acknowledged amongst contemporary researchers.
Both theoretical and experimental evidence of fractal characteristics of Newton‘s method is presented in~ \cite{Drexler1996}.
Another overview of Newton‘s method and the convergence to fractal patterns is published in~\cite{Jr1991}.
Some peculiar examples of fractals obtained using Newton’s method are presented in~ \cite{Cartwright1999}.
The theory for stabilization of Newton‘s method in order to eliminate fractal basin boundaries is developed in~ \cite{Drexler1995}.
Implications of the fractal basin boundaries generated by Newton’s method for the aero-elastic analysis of a helicopter motion is discussed in~ \cite{ChandraSekhar2010}.

Complicated relations between the basins of attraction lead to peculiar applications.
An in-depth analysis of interwoven basins of attraction using a damped Newton’s method is discussed in~ \cite{Epureanu1998}.
A graphical presentation of interlacement amongst three different basins of attraction in Newton’s method is presented in~ \cite{Frame2007}.

A variety of alternatives and modifications to Newton's method are known.
A modification of Newton’s method using some novel adaptive step size control procedure is proposed in~ \cite{Amrein2014}.
Standard Newton’s method, Halley’s method, and Schroder’s method is compared in terms of structural characteristics of Julia sets in~ \cite{Wang2007}.
A variety of different possible generalizations of Newton’s method is reviewed in~ \cite{GILBERT2001}.



\paragraph{Wada property}
Rigorous theorems and important statements regarding Wada basin boundaries and basin cells are presented in~ \cite{Nusse1996}.
Wada property for different types of attractors including strange nonchaotic attractors is discussed in~ \cite{Zhang2012}.
Sufficient and necessary conditions guaranteeing that three Wada basins are emerging from a tangent bifurcation are presented in~ \cite{Breban2005}.

Wada property emerges in a variety of systems of high interest in physics.
Unpredictable behavior of Wada basin boundaries in the Duffing oscillator is noted in~ \cite{Aguirre2002}.
Wada property in some systems of chaotic scattering with multiple exit modes is analyzed in~ \cite{POON1996}.
Topological characteristics, including Wada property, are considered for some systems of chaotic scattering in~ \cite{Sweet1999}.
Fractal and – more specifically – Wada exit basin boundaries are analyzed in a tokamak system in~ \cite{PORTELA2007}.

Basins are highly interwoven even in non-standard situations.
Seemingly unexpected situations where basins of attraction have Wada property are revealed in~ \cite{Kennedy1991}.

Wada effect is present in nature.
Unpredictability of ecological models related to Wada basins is interpreted graphically in~ \cite{Vandermeer2004}.
Examples of Wada characteristic in a periodically forced Lotka-Volterra predator-prey model are found in~ \cite{Vandermeer2001}.

Modifications and generalizations of Wada quality are proposed by contemporary researchers.
Transitions from totally Wada basins to partially Wada basins and vice versa are constructed in~ \cite{Zhang2013}.
A novel method for testing for basins of Wada is proposed in~ \cite{Daza2015a}.



\section{Newton's discrete dynamical system}
Basic Newton's method (also known as the Newton-Raphson method) is one of the most influential methods for finding the roots of a real-valued polynomial $p(x)$~\cite{Atkinson1978}. 

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{basin1}
	\caption[Basins of attraction for the Newton's discrete dynamical system]
	{Basins of attraction for the NDDS with $p(z)=z^3-1$. 
		Each color corresponds to the different attractor 
		$\cA_k$, where $k \in \{ \, 1,2,3 \,\}$.}
	\label{fig:basin1}
\end{figure}

After the method was established in the seventeenth century, modern interpretations and implementations began to differ substantially from the original version.

In the nineteenth century Schröder~\cite{Schrder1870} and Cayley~\cite{Cayley1879} came up with problems and solutions that eventually led to the formal generalization of the Newton's method for a polynomial $p(z)$ with complex coefficients.
In this work it is referred to as the Newton's discrete dynamical system.



\subsection{Concept}
A Newton's dynamical system $f \colon \bC \to \bC$ is a discrete dynamical system fully described by its iterations $z_{k+1} = f(z_k)$, 
where $z_k,z_{k+1} \in \bC$.

For a given complex polynomial $p(z)$ a single Newton's iteration at a point $z \in \bC$ is defined as
\begin{equation}
f_p(z) = z - \frac{p(z)}{p'(z)}.
\end{equation}

Once the evolutionary process is fully described, the discrete Newton's dynamical system (NDDS for short) corresponding to some complex polynomial $p(z)$ can be considered.
The behavior of the aforementioned dynamical system is characterized by orbits 
$\{\, z_0,\ z_1,\ z_2,\ \ldots \,\}$. 
Each orbit is determined unambiguously by the initial seed $z_0 \in \bC$ using the known iterative process
\begin{equation}
z_n = f_p^{\circ n} (z_0), \quad \forall n \in \bN.
\end{equation}
The emphasis on a general polynomial $p$ is omitted during the further analysis. 
The third degree polynomial $p(z) = z^3 - 1$ is taken by default, unless specified otherwise.

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{basinP}
	\caption{Basins of attraction for the NDDS with polynomials of higher order. 
		Different polynomials $p(z)$ are used. (a) }
	\label{fig:basinP}
\end{figure}

In figure~\ref{fig:basin1} basins of attraction $\cB_k$, where $k \in \{ \, 1,2,3 \,\}$, of the NDDS are calculated and presented visually using the default polynomial $p(z) = z^3 - 1$.
It is apparent that the basins are intertwined in a complex manner and further investigations are needed.

Polynomials of higher order $p(z) = z^4-z$ and $p(z)= z^5-1$ are also assigned to NDDS and presented visually in figure~\ref{fig:basinP}.
In this case similarly complex processes are observed near the boundary of basins $\cBo$.

A variation of escape time algorithm is used for calculations.
The appropriate attractor is assigned to an initial seed $z_0 \in \bC$ after $n=30$ iterations. 



\subsection{Properties}
\paragraph{Attractors}
Newton's discrete dynamical system $f_p$ has some attractors $\cA \subset \bC$, provided that the polynomial $p$ is non-constant.
The set of attractors comprises the fixed points satisfying the definition $\{\, r \in \bC \mid p(r)=0 \,\}$. 
Consequently, it is important to understand the basins of attraction $\cB$ for each attractor - the structure, properties and dynamics of these peculiar sets~\cite{Drexler1996a}.

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{HRank}
	\caption[$H$-ranks for the Newton's discrete dynamical system]
	{$H$-ranks for the NDDS with $p(z)=z^3-1$.}
	\label{fig:basinbigh}
\end{figure}
	
	
	
\paragraph{Basin boundaries}
In the twentieth century Fatou~\cite{Fatou1919} and Julia~\cite{Julia} made some independent discoveries regarding the basins of attraction $\cB$ and especially the boundaries of these basins $\cBo$ that are present in NDDS.
If there are multiple Fatou domains (basins) $F_k = \cB_k$, for some $k = \ival{1}{n}$, then each point of the Julia set (boundary) $J = \cBo$ must contain points from multiple basins in its neighborhood.
If there are more than two different basins of attraction $n>2$, then the Julia set is not a simple curve but rather a fractal shape $J = \cF$~\cite{Hubbard2001}.
	
	
	
\paragraph{Speed of convergence}
Another important aspect is the speed of convergence that is characterized by $H$-ranks.
In figure~\ref{fig:basinbigh} Hankel ranks are calculated using the default polynomial $p(z) = z^3 - 1$.
Since the convergence of a Julia set $J$ cannot be predicted, Hankel ranks are substantially higher in the vicinities of the basin boundary $\cBo$.
It also shows that the system can be very sensitive to its choice of starting points outside of certain regions.



\subsection{Generalization}
NDDS itself is a classical tool whose typical speed of convergence varies from quadratic to linear depending on initial conditions~\cite{Holt1984}.
A more general case is considered in order to gain additional flexibility
\begin{equation} \label{eq:rNDDS}
f_p(z) = z - \alpha \frac{p(z)}{p'(z)}.
\end{equation}
The modified Newtonian iteration (\ref{eq:rNDDS}) introduces an arbitrary coefficient $\alpha \in \bC$ instead of a constant value $\alpha = 1$.

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{basin02}
	\caption{Basins of attraction for the relaxed NDDS with $p(z)=z^3-1$. 
		Different parameters $\alpha \in \bR$ are used.}
	\label{fig:basins_lo-hi}
\end{figure}

This generalization is called a relaxed Newton's discrete dynamical system~\cite{GILBERT2001}. 
It introduces a quantitative change in the speed of convergence as well as a qualitative change in the basins of attraction for the NDDS, even for $\alpha \in \bR$.
Typically $0 < \alpha < 1$ softens the fractal pattern of the basin boundary while performing smaller changes in variable during every iteration (see fig.~\ref{fig:basins_lo-hi}(a)).
On the other hand, $\alpha > 1$ typically sharpens the fractal pattern while providing bigger and more aggressive changes in variable (see fig.~\ref{fig:basins_lo-hi}(b)). 
Overall this effect can be clearly seen in figure~\ref{fig:basins_lo-hi}.



\section{Fractal dimension}
\subsection{Concept}
There are multiple characteristics that may be referred to as fractal dimensions.
These measures provide an objective means to compare sets in terms of various features. 

Box counting dimension (also known as Minkowski or Minkowski–Bouligand dimension) provides a way of determining the fractal dimension of a set $\cF$ in any metric space. 
However some more preliminary definitions are necessary before further introduction.

The box of side length $\varepsilon$ around the point $z_0 \in \bC$ is defined
\begin{multline}
	B(\varepsilon, z_0) = \left\{ z \in \bC \left| \Re (z_0) - \frac{\varepsilon}{2} \le \Re (z) \le \Re (z_0) + \frac{\varepsilon}{2}, \right. \right. \\
	\left. \left. \Im (z_0) - \frac{\varepsilon}{2} \le \Im (z) \le \Im (z_0) + \frac{\varepsilon}{2} \right. \right\}.
\end{multline}


The box defined above is actually a closed ball described using Manhattan metric~\cite{Krause1975} instead of a more typical Euclidean one.
Nevertheless, it is useful when working in discrete grids which typically occur in computational environments.
	
The minimal number of boxes of side length $\varepsilon$ that are needed to cover a given closed and compact set $\cF$ is denoted
\begin{equation}
	N(\varepsilon) = \min \left\{ n \in \bN \left| \cF \subset \bigcup_{k=1}^n B(\varepsilon, z_k), z_k \in \bC \right. \right\}.
\end{equation}

Such a number will always be found in case of $\cF$ being compact because it follows from the very definition of compactness that there exists a finite subcover of (open) balls.
Amongst these well-defined and finite coverings some (or at least one) will be minimal.
		
Now a particular proposed dimension $D$ is related to the number $N$ such that
\begin{equation}
	N(\varepsilon) \approx C \varepsilon^{-D}, \quad \text{for some } C>0;
\end{equation}
and the above approximation becomes more precise as the multiplier $\varepsilon$ decreases.
Then it is natural to solve for $D$ by taking the logarithm to the base $e$ and obtain
\begin{equation} \label{eq:DwithC}
	D \approx \frac {\log N(\varepsilon) - \log C}{\log (1/\varepsilon)}.
\end{equation}
		
Since the evaluation of dimension in question involves counting the number of $\varepsilon$-sized boxes $N(\varepsilon)$, it suffices to have a reasonable approximation of $\cF$ and work at a fine precision $\varepsilon$.
Then the second summand in the numerator of \eqref{eq:DwithC} disappears and this leads to the following definition.

		
The box counting dimension (or simply dimension) $D$ of a compact non-empty set $\cF \subset \bC$ is defined as
\begin{equation} \label{eq:D}
D(\cF) = \lim_{\varepsilon \to 0} \frac {\log N(\varepsilon)}{\log (1/\varepsilon)};
\end{equation}
where $N(\varepsilon)$ is the number of $\varepsilon$-sized boxes that are required to cover $\cF$.

			
\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{fractal}
	\caption{Basin boundary $\cF = \cBo$ for the NDDS with $p(z)=z^3-1$.}
	\label{fig:basinbigedge1}
\end{figure}
				
It is possible to extend the definition of $D$ and provide a value of dimension for a wider variety of sets.
It is possible to use the following superior limit
\begin{equation} \label{eq:genD}
	D(\cF) = \lim_{\varepsilon \to 0} \sup \frac {\log N(\varepsilon)}{\log (1/\varepsilon)}.
\end{equation}
It can be proved that the above two presentations \eqref{eq:D} and \eqref{eq:genD} are mathematically consistent~\cite{Barnsley2000}.
However, the latter is obviously more general. 
This broader definition \eqref{eq:genD} can be applied in some more complicated cases where the first one fails.
However, in the scope of this work it is sufficient to use the former approach \eqref{eq:D}.



\subsection{Algorithm} \label{sec:algD}
In short, the conventional idea of approximation involves scanning a non-overlapping $\varepsilon$-sized grid, finding the portions containing $\cF$, and making conclusions according to the definition of box counting dimension. 

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{algoD}
	\caption{The principle of box counting using boxes of various sizes $\varepsilon$.
		The digital representation of $\cF$ is split into an $\varepsilon$-grid, then count the nodes where the basin boundary $\cBo$ is present.
		(a) $\varepsilon = 0.1;\ N(\varepsilon) = 145;$ (b) $\varepsilon = 0.05;\ N(\varepsilon) = 355.$}
	\label{fig:boxCountGrid}
\end{figure}

In reality the ability to reduce $\varepsilon$ is limited. For digital images (the representation of fractal structures) it is not possible to zoom more than to an individual pixel.
The proposed solution:
\begin{enumerate}
	\item Look at some finest $\varepsilon \in S$ values. \\
	These should initially cover $1 \times 1$ grid of pixels, then $2 \times 2$ grid pixels and so on (see fig.~\ref{fig:boxCountGrid}).
	\item Calculate the observations $\log N(\varepsilon)$ and $\log (1/\varepsilon)$ in each case. \\
	This step is self-explanatory. The definition of $N$ is applied.
	\item Approximate the slope using the least square linear regression or an alternative method. \\
	Assume that some pairs of observations $(x_k, y_k)$, $k = \ival{1}{n}$, are supposed to be related $y_k = \gamma x_k+C$ up to some level of disturbance.
	Here $\gamma$ is the slope and $C$ is the constant term. 
	Then the evaluation that minimizes root-mean-square error (RMSE) is
	\begin{equation}
	\gamma (x, y) = \frac{n \sum_{k=1}^n(x_k y_k) - (\sum_{k=1}^n x_k)(\sum_{k=1}^n y_k)}{n \sum_{k=1}^n x_k^2 - (\sum_{k=1}^n x_k)^2}.
	\end{equation}
\end{enumerate}

After aforementioned procedures the approximation of fractal dimension $D$ may be expressed
\begin{equation}
D(\cF) \approx \gamma (\log (1/\varepsilon), \log N(\varepsilon)).
\end{equation}
This approximation is used in further research and analysis.



\section{Wada measure}
In theoretical mathematics, there exists a concept called lakes of Wada.
It occurs in a plane which is divided into three disjoint connected open sets that have a peculiar and highly counterintuitive property: they all share the same boundary.

In applied mathematics, there exists a variety of vastly different nonlinear dynamical systems describing both natural and unnatural phenomena.
Typically, these systems possess multiple nontrivial attractors. 
It is therefore understandable that the principles of Wada are defined in terms of basins of attraction and their respected boundaries, which are shared.

Let's construct a region that has full Wada property.
For that purpose, three different basins of attraction $R$, $Y$, $B$ are used.
The basins correspond to colors red, yellow and blue respectively.
\begin{enumerate}
	\item Without loss of generality it can be said that the region is rectangular. \\
	Initially all points in the region are undefined (not assigned to any basin of attraction).
	\item The undefined region is divided vertically into three equal parts. \\
	Side parts are assigned to two different basins of attraction; the middle part is left undefined.
	\item The undefined parts are divided vertically into three equal even smaller parts. \\
	Side parts are left undefined; the middle part is assigned to the basin which is not nearby.
	\item Step 3 is repeated indefinitely.
\end{enumerate}
	
\begin{figure}[ht]
	\centering
	\includegraphics[width=4.5cm]{wada}
	\caption{Emergence of Wada property. A region is divided into three pieces, side pieces are assigned to two different basins of attraction, the middle piece is undefined. In every subsequent turn an undefined portion is again divided into three pieces, side pieces are undefined, the middle piece is assigned to the basin of attraction which is not nearby.}
	\label{fig:wada_sch}
\end{figure}
	
As the number of repeated iterations $n$ increases, the set of undefined points is getting smaller.
In the limit case $n \to +\infty$, a whole region of points is assigned to some basins $R$, $Y$, $B$.
Moreover, all these basins have a common boundary, thus the full Wada property.
The whole process is illustrated in figure~\ref{fig:wada_sch}.



\subsection{Concept}
As already discussed, the situation when every boundary point neighbors more than two distinct basins of attraction $\cB_k$, $k \in \ival{1}{n}$, is known as the Wada property~\cite{Kennedy1991}.
If the system has exactly three different attractors $\cA_1,\ \cA_2,\ \cA_3$, it follows that all basins of attraction $\cB_1,\ \cB_2,\ \cB_3$ have a common boundary $\cBo$.
Some more preliminary definitions are needed before proceeding with quantitative approximations of Wada measure.

The number of $n$-boxes $N_n (\varepsilon)$ is the minimal number of boxes (according to the definition of $N$) that satisfy an additional property
\begin{equation}
	B(\varepsilon, z) \cap \cB_k \neq \emptyset, \quad \text{for all } k \in \{ \, k_1,k_2,\ldots, k_n \, \};
\end{equation}
for a fixed side length $\varepsilon$ and compact nonempty set $\cF$.


Simply put, the number of $n$-boxes counts the size of (partial) $\cF$ covering which contains points from at least $n$ different basins of attraction.
Then the following inequality holds
\begin{equation}
0 \le N_n(\varepsilon) \le N(\varepsilon), \quad \forall n \in \bN,\ \forall \varepsilon > 0.
\end{equation}

Let's look at the case where a given dynamical system has exactly three attractors and three corresponding basins of attraction $\cB_1,\ \cB_2,\ \cB_3$ more closely.
In extreme cases where the basins are relatively far away and form distinct boundaries it is reasonable to expect $N_3(\varepsilon) \approx 0$, 
whereas if basins are intertwined and close together it should be $N_3(\varepsilon) \approx N(\varepsilon)$.

Finally, the Wada measure can be defined with precision.
A Wada measure $W$ for a compact non-empty set $\cF \subset \bC$ is defined as
\begin{equation}
	W(\cF) = \lim_{\varepsilon \to 0} \frac{N_3(\varepsilon)}{N_2(\varepsilon)} = \lim_{\varepsilon \to 0} \frac{N_3(\varepsilon)}{N(\varepsilon)}
\end{equation}
where $N(\varepsilon)$ and $N_3(\varepsilon)$ is the number of $\varepsilon$-sized boxes that cover $\cF$.

In terms of the classical theory of probability, the Wada measure is the probability of a random point taken from boundary $\cBo$ having at least three different basins of attraction in its immediate neighborhood.
If the region of interest has full Wada property, then its boundary $\cBo$ has a theoretical Wada measure $W(\cBo) = 1$.
On the contrary, if the region does not resemble Wada situation at all, then $W(\cBo) = 0$.



\subsection{Algorithm} \label{sec:algW}
Once again, the idea involves scanning a non-overlapping $\varepsilon$-sized grid, finding the portions containing $\cF$, counting the number of basins of attraction that they contain, and making conclusions according to the definition of Wada measure. 

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{algoW}
	\caption{The principle of Wada measure using boxes of various sizes $\varepsilon$.
		The digital representation of $\cF$ is split into an $\varepsilon$-grid, then count the nodes where the basin boundary $\cBo$ is present and count the occurrences from different basins of attraction.
		(a) $\varepsilon = 0.1;\ N_3(\varepsilon) = 143;\ N(\varepsilon) = 145;$
		(b) $\varepsilon = 0.05;\ N_3(\varepsilon) = 342;\ N(\varepsilon) = 355.$}
	\label{fig:boxCount}
\end{figure}

The ability to reduce $\varepsilon$ is similarly limited to no more than an individual pixel.
The proposed solution is this:
\begin{enumerate}
	\item Look at some finest $\varepsilon \in S$ values. \\
	These should initially cover $2 \times 2$ grid of pixels, then $3 \times 3$ grid pixels and so on (see fig.~\ref{fig:boxCount}).
	\item Calculate the observations $N(\varepsilon)$ and $N_3(\varepsilon)$ in each case. \\
	The empirical probability of any given box being a $3$-box is $N_3(\varepsilon) / N(\varepsilon)$.
	\item Take the mean empirical probability of the observations. 
\end{enumerate}

After aforementioned procedures the outcome may be expressed as
\begin{equation}
W(\cF) \approx \frac{1}{|S|} \sum_{\varepsilon \in S} \frac{N_3(\varepsilon)}{N(\varepsilon)}.
\end{equation}
Realistically, the approximated value of $W(\cF)$ is never quite equal to $1$. 
On the other hand, it serves its purpose of measuring and comparing Wada characteristics of different dynamical systems and situations.
This approximation is mainly used in further research and analysis.



\section{Analysis of basin boundaries}
Artificially generated visual representations of attractors and basins of attraction are amongst typical choices for researchers who seek to describe and analyze the behavior of some dynamical systems~\cite{Ott2002}. 
Therefore, it is important to do a quality presentation of characteristics that describe these basins of attraction, relations between aforementioned characteristics and possible implications of these results.

A scope of initial conditions $z_0 \in \bC_1$ is considered. 
These are the conditions that belong to a complex square defined as $\bC_1 = [-1,1]^2$.
This set includes all attractors for the default NDDS polynomial $p(z)=z^3-1$ and otherwise suits the needs of this work.
Within the chosen scope values which are $|\Dez| = 0.0025$ distance apart are evaluated, for example $-1, -0.9975, -0.995, \ldots , 1$.
It is easy to see that after aforementioned discretization a $801 \times 801$-sized grid of possible values for $z_0$ is obtained.

Similarly, a scope of parameters $\alpha  \in \bC_1$ is considered. 
It is enough for the experiments because outside of this set the behavior of NDDS can be quite extreme and too rapid-changing for the delicate numerical analysis.
Within the chosen scope some values which are $|\Delta \alpha| = 0.01$ distance apart are chosen, for example $-i, -0.99i, -0.98i, \ldots , i$.
Once again, it is easy to see that after discretization a $201 \times 201$-sized grid of possible values for $\alpha$ is obtained.

Lastly, the number of iterations used in the model is $n=30$. 
It corresponds to the depth of the trajectories $(z_0,\ z_1,\ z_2,\ \ldots,\ z_{30})$ and after $z_{30}$ the orbit is assigned to the nearest attractor $\cA$.
It is possible to use a higher depth but the orbits tend to stabilize before $n$ recalculations.
Also the number of elements in the grid is limited anyway.
Therefore, the benefits of significantly higher depth are questionable in the present setting.



\subsection{Fractal dimension of boundaries}
For the purposes of research the algorithm discussed in subsection \ref{sec:algD} is used.
In the process of approximation, different coverings ranging from $1 \times 1$ to $100 \times 100$ pixels are taken into account.
This means $|S|=100$ cases overall.

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{typicalD}
	\caption{Basins of attraction for the relaxed NDDS with varying values of fractal dimension. 
		Two different system parameters $\alpha \in \bC$ are used.
		(a) $\alpha = -0.55+0.6i;\ D(\cF_\alpha)=1.21;$
		(b) $\alpha = 0.5+0.9i;\ D(\cF_\alpha)=1.63.$}
	\label{fig:basins_D}
\end{figure}

In general, a fractal dimension $D$ is a characteristic of complexity comparing how detail in a pattern changes with the scale at which it is being measured.
For smooth simple curves this characteristic is a constant unit $D=1$ meaning that there is no change in detail. But other possibilities exist.
For example, let's take a particular parameter $\alpha = -0.55+0.6i$. 
Using the relaxed NDDS, its basins of attraction $\cB$, basin boundary $\cBo = \cF$ and finally the corresponding fractal dimension $D(\cF_\alpha)=1.21$ is obtained. 
This result is quite different from, say, $\alpha = 0.5+0.9i$ and corresponding dimension $D(\cF_\alpha)=1.63$.
The comparison can be seen visually in figure~\ref{fig:basins_D}.

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{sectionD}
	\caption{Fractal dimensions for the relaxed NDDS with varying parameter $\alpha \in \bC$.
		(a) $\alpha \in [0,1]$;
		(b) $\alpha \in [0,1]i$.}
	\label{fig:sectionD}
\end{figure}

As the parameter $\alpha$ fluctuates starting from $\alpha = 0$, the changes in global characteristics are inspected.
At this stage the aim of the procedure is to detect any possible peculiarities.

Initially some small positive constant $\varepsilon \approx 0.001$ is added so that $\alpha \in [0,1]$.
Beginning from $D(\cF_0) \approx 1$ the fractal dimension increases almost monotonically until $D(\cF_1) \approx 1.38$ and onwards (for example, $D(\cF_2) \approx 1.60$).
This effect can be clearly seen in figure~\ref{fig:sectionD} part (a).

Next, starting from the same $\alpha = 0$, some small imaginary constant $\varepsilon \approx 0.001i$ is added so that $\alpha \in [0,1]i$.
Effectively this creates a section of the parameter plane along the imaginary axis.
But this time the dimension does not increase monotonically at all, see figure~\ref{fig:sectionD} part (b).
Instead it demonstrates periodic-like behavior and has some local minima approximately at $\alpha \in \{ \, 0.2i, 0.4i, 0.6i, 0.8i \, \}$.
This is indeed a peculiar behavior that requires further investigation.

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{planeD}
	\caption{Fractal dimension $D(\cF_\alpha)$ in the parameter plane $\alpha \in \bC$.}
	\label{fig:planeD}
\end{figure}

Then some computationally-intensive calculations are performed for many more possible $\alpha$ values.
As a result, fractal dimensions for the whole grid of parameter values is obtained.
This result is presented in figure~\ref{fig:planeD}.
It shows that the fractal dimension $D$ is a highly non-trivial function of complex parameter $\alpha \in \bC$ which apparently is symmetric with respect to the $\Im (\alpha) = 0$.

For $\Re (\alpha) \le 0$, the dimensions tend to be relatively low, with the maximum being found to be $D(\cF_{0.45i}) \approx 1.39$.
The periodic-like behavior along imaginary axis is also present only in this semi-plane.
Otherwise the imaginary part of the parameter $\alpha$ does not impact the observed dimension dramatically.

On the other hand, let's look at $\Re (\alpha) \ge 0$. In this semi-plane the dimensions vary substantially between 
$D(\cF_0) \approx 1$ and $D(\cF_{0.76 + 0.98i}) \approx 1.68$.
The periodic-like behavior is not to be found here.
As the $\Im (\alpha)$ approaches either $\pm 1$, the observed dimension increases dramatically.



\subsection{Wada measure of boundaries}
The algorithm discussed in subsection \ref{sec:algW} is used for the following part of this research.
In the process of approximating Wada measure different coverings ranging from $2 \times 2$ to $101 \times 101$ pixels are taken into account (the single pixel case is trivial).
This means $|S|=100$ cases overall.

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{typicalW}
	\caption{Basins of attraction for the relaxed NDDS with varying values of Wada measure. 
		Different parameters $\alpha \in \bC$ are used.
		(a) $\alpha = -0.85+0.53i;\ W(\cF_\alpha)=0.28;$
		(b) $\alpha = 0.1+0.6i;\ W(\cF_\alpha)=0.88.$}
	\label{fig:basins_W}
\end{figure}

In general, Wada measure $W$ indicates what percentage of boundary points $\cF$ is neighboring more than two basins of attraction simultaneously.
Naturally $W=0$ corresponds to $0\%$ while $W=1$ corresponds to $100\%$.

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{sectionW}
	\caption{Wada measures for the relaxed NDDS with varying parameter $\alpha \in \bC$.
		(a) $\alpha \in [0,1]$;
		(b) $\alpha \in [0,1]i$.}
	\label{fig:sectionW}
\end{figure}

For example, let's take a particular parameter $\alpha = -0.85+0.53i$. 
Using Newton's discrete dynamical system its basins of attraction $\cB$, basin boundary $\cBo = \cF$ and finally the corresponding Wada measure $W(\cF_\alpha)=0.28$ is obtained. 
This result is very different from, say, $\alpha = 0.1+0.6i$ and corresponding measure $W(\cF_\alpha)=0.88$.
The comparison is presented visually in figure~\ref{fig:basins_D}.

As the parameter $\alpha$ varies in some direction starting from $\alpha = 0$, the changes in Wada measure are inspected.
Some resemblance to fractal dimension is expected.
However, it's worth emphasizing that Wada measure takes into account more data (basins of attraction themselves) compared to fractal dimension (only basin boundaries).

Initially some reasonably small positive constant $\varepsilon \approx 0.001$ is added so that $\alpha \in [0,1]$.
Beginning from $W(\cF_0) \approx 0$ the Wada measure then increases rapidly until approximately $\alpha \approx 0.03$ when $W(\cF_{0.03}) \approx 0.91$.
Afterwards it stays at a similar level until the end of simulations when $W(\cF_1) \approx 0.96$.
This effect can be clearly seen in figure~\ref{fig:sectionW} part (a).

In another scenario, let's add some small imaginary constant $\varepsilon \approx 0.001i$ so that $\alpha \in [0,1]i$.
This creates a section of the parameter plane along the imaginary axis.
This time the measure behaves in a very similar manner to fractal dimension, see figure~\ref{fig:sectionW} part (b).
Namely it demonstrates periodic-like behavior and has some local minima approximately at $\alpha \in \{ \, 0.2i, 0.4i, 0.6i, 0.8i \, \}$.

Overall this shows an expected resemblance compared to fractal dimension in one case (imaginary values), yet yields some new results in another scenario (real parameters).

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{planeW} 
	\caption{Wada measure $W(\cF_\alpha)$ in the parameter plane $\alpha \in \bC$.}
	\label{fig:planeW}
\end{figure}

Once again some computationally-intensive calculations for many more possible $\alpha$ values are performed.
As a result, Wada measure for the whole grid of parameter values $\alpha \in \bC_1$ is obtained.
This obtained result is presented in figure~\ref{fig:planeW}.
It shows that the Wada measure $W$ is indeed a non-trivial function of complex parameter $\alpha \in \bC$.
It is also apparently the case that the characteristic $W(\cF_\alpha)$ is invariant under $\alpha = x \pm iy$.

For $\Re (\alpha) \le 0$, the Wada measures vary significantly within $W \in [0.03, 0.90]$.
The average measure in this case is $\overline{W} \approx 0.53$.
The periodic-like behavior along imaginary axis is present only in this semi-plane.
This time the imaginary part of the parameter $\alpha$ can impact the observed measure noticeably.

On the other hand, let's look at $\Re (\alpha) \ge 0$. 
In this semi-plane the measure is relatively high.
The highest observed value is $W(\cF_{0.59 - i}) \approx 0.99$.
In fact the values are high almost everywhere except for $\Re (\alpha) \approx 0$ with average being $\overline{W} \approx 0.94$.
Also the periodic-like behavior is not found and $\Im (\alpha)$ has no substantial impact on the observed Wada measures.



\subsection{Relation between characteristics}
The results concerning fractal dimensions and Wada measures have been described separately.
It was presented how and when these characteristics change within the family of basin boundaries.
The logical follow-up is to integrate the two characteristics and present the joint results regarding the relation between both measures.

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{scatter}
	\caption{Fractal dimensions $D(\cF)$ and Wada measures $W(\cF)$ for all parameters $\alpha \in \bC_1$.}
	\label{fig:scatterDW}
\end{figure}

Initially the scatter points are marked in figure~\ref{fig:scatterDW} to plot the set of observations $D$ and $W$ for the data.
Some tendencies can be noticed right away.
Apparently there exists a positive correlation between the characteristics: the higher the fractal dimension $D$, the higher the Wada measure $W$.
Different coefficients may be used to evaluate possible correlation:
\begin{enumerate}
	\item Pearson's correlation coefficient measures the linear relationship between two continuous variables. 
	The normality is not assumed nor checked. In fact only finite (co)variances are assumed. 
	The obtained outcome is
	$\rho_{D,W} = 0.82$
	which indeed reveals a positive correlation.
	\item Spearman's correlation coefficient measures the monotonic relationship between two continuous variables. 
	The outcome is calculated very similarly, yet the measures themselves are replaced with ranks
	$r_{D,W} = \rho_{\rank(D),\rank(W)} = 0.87$
	and once again a positive correlation is revealed.
	Because of ranking feature, the measure is relatively robust to outliers (unlike Pearson's correlation).
	It is possible that there exist some numerical outliers since the nature of the calculations is quite delicate.
\end{enumerate}

Despite some positive correlation the relationship is still complex.
It is possible to provide a sequence of fractal basin boundaries whose dimension $D$ strictly increases, yet at the same time the corresponding Wada measure decreases.
The aforementioned effect can be demonstrated in the scatter plot (see figure~\ref{fig:scatterDW}) by selecting a negatively correlated subset of observations ($\rho \approx -1$).

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{minmax}
	\caption{Minimum and maximum fractal dimensions for the $\varepsilon$-neighborhoods of a fixed Wada measure $W(\cF)$.}
	\label{fig:cumulativeC}
\end{figure}

Now in figure~\ref{fig:cumulativeC} it is checked what fractal dimensions $D$ exist when a particular Wada measure $W$ is fixed.
It is actually possible to find relatively low fractal dimensions $D < 1.2$ for (almost) all Wada measures $W < 0.9$.
Afterwards when $W \ge 0.9$ the minimal dimension $D$ is necessarily higher within the scope of parameters $1.2 \le D < 1.6$.
On the other hand, the maximal dimension increases along with fixed Wada measure with few exceptions in the present setting.

These observations can also be presented the other way around.
For example, once the complex patterns have $D > 1.2$, a substantial Wada measure is expected as well - otherwise there would be no matches.



\section{Examples}
\subsection{Uncertainty of the final attractor}
In order to check the underlying uncertainty of the final attractor the setting of the NDDS is fixed as described below.
The initial seeds belong to a grid of values around $z_0 = -0.793$ within the radius of $|\Dez_0| = 0.01$.
To ensure that there are enough simulations the distance between nodes in the grid has to be sufficiently small, around $\varepsilon \approx 0.0006$.
This leads to the total number of simulations being $s = 795$ which is considered to be enough for reliable results.

\begin{figure*}[ht]
	\centering
	\includegraphics[width=12cm]{uncertainty}
	\caption{Uncertainty of the final attractor when the initial seed $z_0 = -0.793$ fluctuates within $|\Dez_0| = 0.01$ and the parameter $\alpha$ is slightly perturbed.
		(a) $\alpha = 0.97;$
		(b) $\alpha = 1;$
		(c) $\alpha = 1 + 0.005i.$}
	\label{fig:uncertainty}
\end{figure*}

Initially the control parameter $\alpha = 0.97$ is set.
It leads to the emergence of slightly smoothed basin boundary.
After running the simulations, it is noticeable that the outcomes are quite tendentious: $523$ cases converge to the attractor $\cA_3$ while the other two $\cA_1$ and $\cA_2$ attract $s(\cA_1) = s(\cA_2) = 136$ precisely.
The radar plot can be seen in figure~\ref{fig:uncertainty}(a).

Next the control parameter $\alpha = 1$ is set.
It leads to the emergence of a standard basin boundary of the NDDS.
Simulations reveal that the likelihood of outcomes is almost even now: $s(\cA_3) = 259$ cases go to the attractor $\cA_3$ while $268$ cases are attracted by $\cA_1$ and $\cA_2$ each.
The result is shown in figure~\ref{fig:uncertainty}(b).

Finally, the control parameter $\alpha = 1 + 0.005i$ is chosen.
It leads to the emergence of a rotated boundary.
After inspecting the outcomes, the change in situation is seen: attractor $\cA_2$ is now dominant with $s(\cA_2) = 472$ cases while $\cA_1$ and $\cA_3$ attract $261$ and $62$ different initial seeds respectively.
The visual outcome is shown in figure~\ref{fig:uncertainty}(c).

\begin{table}[h]
	\centering
	\begin{tabular}{| l | c | c | c |}
		\hline			
		$\alpha$ & $s(\cA_1)$ & $s(\cA_2)$ & $s(\cA_3)$ \\
		\hline \hline
		$0.97$ & $136$ & $136$ & $523$ \\ \hline
		$1$ & $268$ & $268$ & $259$ \\ \hline
		$1+0.005i$ & $261$ & $472$ & $62$ \\ \hline
	\end{tabular}
	\caption{Distribution of simulations (out of $s=795$) that approach different attractors $\cA_1,\ \cA_2,\ \cA_3$ under various values of parameter $\alpha$.}
	\label{tab:sim}
\end{table}

The overall resulting situation is reviewed in table~\ref{tab:sim} and presented visually in figure~\ref{fig:uncertainty}.
To sum up, some complicated interactions between the resulting attractors are observed during simulations. 
Moreover, these interactions involve more than two attractors simultaneously.
This means that during research it is crucial to consider not only the boundary itself (in terms of fractal dimension or equivalent characteristic) but also the neighboring basins of attraction (in terms of Wada measure or some other means).



\subsection{Sensitivity to the control parameter}
In some cases it is important to stabilize and control the nonlinear dynamical system as required.
It is not always an easy task. 
Some particular initial seeds are chosen
$z_0 \in \{ \, -0.793-0.001i, -0.793, -0.793+0.001i \, \}$, 
then the evolution of dynamics is observed while the control parameter $\alpha = 1$ is slightly perturbed until $\alpha = 0.99$.

\begin{figure}[ht]
	\centering
	\includegraphics[width=8cm]{control}
	\caption{Trajectories of the Nn orbits when the initial seed $z_0 = -0.793$ varies by $\Delta z = 0.001i$ and the parameter $\alpha$ is slightly perturbed.
		(a) $\alpha = 1$
		(b) $\alpha = 0.99$.}
	\label{fig:trajectories}
\end{figure}

It is not possible to plot complex orbits in less than three dimensions so other acceptable ways of representing the situation are considered.
Because of fluctuations in magnitude that occur while observing orbits the complex arguments (see figure~\ref{fig:trajectories}) are plotted.
Understandably the convergence of arguments does not ensure the convergence of values hence this aspect is checked separately.

Then $\alpha = 1$ is set along with aforementioned initial seeds which have the property $\Arg(z_0) \approx \pi$. 
As the orbits evolve the trajectories diverge briefly, approximately until iteration $n=4$ and begin to stabilize afterwards.
By the time the iteration $n=35$ is reached, the arguments are stable and so are the values.
In fact the values have converged to three distinct attractors $\cA_1,\ \cA_2,\ \cA_3$.
The values are shown in figure~\ref{fig:trajectories}(a).

In another case the control parameter is perturbed to $\alpha = 0.99$.
It is a relatively slight shift yet the effect is critical.
All initial seeds remain the same and the property $\Arg(z_0) \approx \pi$ does not change during iterations.
In fact the values continue to remain in the starting region during the whole experimental period $n = \ival{0}{35}$. 
These orbits are presented in figure~\ref{fig:trajectories}(b).

To sum up the trajectories of orbits depend on the control parameter $\alpha$.
In case of more than two attractors the final outcomes are attracted by multiple distinct regions.
Therefore, the ability to predict convergence of an arbitrary initial seed is influenced not only by the positioning and complexity of the basin boundary but also by the intertwining of the basins themselves.
While the formal aspect can be somewhat measured using fractal dimension, the latter requires Wada measure or equivalent tools.



\section{Conclusions}
Newton's discrete dynamical system is analyzed numerically in terms of basins of attraction $\cB$ and their fractal boundaries $\cBo = \cF$, using control parameter $\alpha \in \bC$.

Fractal dimension $D$ is evaluated using the box counting technique. 
Some peculiar dynamical processes are noticed, especially when the imaginary part of $\alpha$ varies, revealing periodic-like behavior.
The dimension itself fluctuates from $D = 1$ in a trivial case, to $D = 1.68$ for a very complicated structure.

Wada measure $W$ is calculated using a novel proposed algorithm. 
The results only somewhat resemble those concerning fractal dimension. 
Most notably the proposed Wada characteristic also takes into account the basins of attraction.
The measure itself varies from $W = 0.03$ in a trivial case, to $W = 0.99$ for especially intertwined boundaries.

The relation between characteristics $D$ and $W$ is highly non-trivial. 
There is a positive correlation but nothing like a bijective correspondence can be defined.
This is understandable since Wada measure takes into account more data.

The uncertainty of the final attractor $\cA$ is examined.
It can be an extremely complicated task to determine when (and where) a specific trajectory converges.
This difficulty to predict the outcome can be evaluated quantitatively in terms of both characteristics.

Unlike other research, the limited precision is emphasized in this work. 
It means that once the grid of value simulations is obtained, it is not possible to zoom in order to obtain an even more detailed picture of the model.
This apparent drawback can also be seen as a realistic situation when only some experimental observations are available instead of the precise model.




%\begin{acknowledgements}
%If you'd like to thank anyone, place your comments here
%and remove the percent signs.
%\end{acknowledgements}

% BibTeX users please use one of
%\bibliographystyle{spbasic}      % basic style, author-year citations
\bibliographystyle{spmpsci}      % mathematics and physical sciences
%\bibliographystyle{spphys}       % APS-like style for physics
\bibliography{library}   % name your BibTeX data base



\end{document}

